--- a/ext/ctype/tests/lc_ctype_inheritance.phpt	2025-10-21 19:23:55.000000000 +0000
+++ b/ext/ctype/tests/lc_ctype_inheritance.phpt	2025-11-18 21:43:27.152659491 +0000
@@ -4,6 +4,9 @@
 ctype
 --SKIPIF--
 <?php
+if (PHP_OS_FAMILY === 'Darwin' && version_compare(php_uname('r'), '24.0.0', '>=')) {
+    die('skip macOS 15 inherits LC_CTYPE into the thread locale');
+}
 if (setlocale(LC_ALL, 'invalid') === 'invalid') { die('skip setlocale() is broken /w musl'); }
 if (!setlocale(LC_CTYPE, "de_DE", "de-DE")) die("skip requires de_DE locale");
 ?>
diff '--color=auto' -Naur a/ext/dom/html5_parser.c b/ext/dom/html5_parser.c
--- a/ext/dom/html5_parser.c	2025-10-21 19:23:55.000000000 +0000
+++ b/ext/dom/html5_parser.c	2025-11-18 21:43:27.152891990 +0000
@@ -268,7 +268,10 @@
 
                 /* xmlIsID does some other stuff too that is irrelevant here. */
                 if (local_name_length == 2 && local_name[0] == 'i' && local_name[1] == 'd' && attr->node.ns == LXB_NS_HTML) {
-                    xmlAddID(NULL, lxml_doc, value, lxml_attr);
+                    if (xmlAddID(NULL, lxml_doc, value, lxml_attr) == 0) {
+                        /* If the ID already exists, the ID attribute still needs to be marked as an ID. */
+                        lxml_attr->atype = XML_ATTRIBUTE_ID;
+                    }
                 }
 
                 /* libxml2 doesn't support line numbers on this anyway, it derives them instead, so don't bother */
diff '--color=auto' -Naur a/ext/dom/php_dom.c b/ext/dom/php_dom.c
--- a/ext/dom/php_dom.c	2025-10-21 19:23:55.000000000 +0000
+++ b/ext/dom/php_dom.c	2025-11-18 21:43:27.153565737 +0000
@@ -492,6 +492,7 @@
 	zend_std_unset_property(object, member, cache_slot);
 }
 
+/* This custom handler is necessary to avoid a recursive construction of the entire subtree. */
 static HashTable* dom_get_debug_info_helper(zend_object *object, int *is_temp) /* {{{ */
 {
 	dom_object			*obj = php_dom_obj_from_obj(object);
@@ -502,6 +503,11 @@
 	dom_prop_handler	*entry;
 	zend_string         *object_str;
 
+	/* As we have a custom implementation, we must manually check for overrides. */
+	if (object->ce->__debugInfo) {
+		return zend_std_get_debug_info(object, is_temp);
+	}
+
 	*is_temp = 1;
 
 	std_props = zend_std_get_properties(object);
diff '--color=auto' -Naur a/ext/dom/tests/gh16317.phpt b/ext/dom/tests/gh16317.phpt
--- a/ext/dom/tests/gh16317.phpt	1970-01-01 00:00:00.000000000 +0000
+++ b/ext/dom/tests/gh16317.phpt	2025-11-18 21:43:27.154367395 +0000
@@ -0,0 +1,20 @@
+--TEST--
+GH-16317 (DOM classes do not allow __debugInfo() overrides to work)
+--FILE--
+<?php
+
+class Demo extends DOMNode {
+    public function __construct() {}
+    public function __debugInfo(): array {
+        return ['x' => 'y'];
+    }
+}
+
+var_dump(new Demo());
+
+?>
+--EXPECT--
+object(Demo)#1 (1) {
+  ["x"]=>
+  string(1) "y"
+}
diff '--color=auto' -Naur a/ext/dom/tests/modern/html/interactions/gh20281.phpt b/ext/dom/tests/modern/html/interactions/gh20281.phpt
--- a/ext/dom/tests/modern/html/interactions/gh20281.phpt	1970-01-01 00:00:00.000000000 +0000
+++ b/ext/dom/tests/modern/html/interactions/gh20281.phpt	2025-11-18 21:43:27.154503051 +0000
@@ -0,0 +1,15 @@
+--TEST--
+GH-20281 (\Dom\Document::getElementById() is inconsistent after nodes are removed)
+--EXTENSIONS--
+dom
+--CREDITS--
+cscott
+--FILE--
+<?php
+$d = \Dom\HTMLDocument::createFromString('<p id="a">b</p><p id="a">c</p>', LIBXML_NOERROR);
+$p = $d->getElementById('a');
+$p->remove();
+echo $d->getElementById('a')->textContent, "\n";
+?>
+--EXPECT--
+c
diff '--color=auto' -Naur a/ext/exif/exif.c b/ext/exif/exif.c
--- a/ext/exif/exif.c	2025-10-21 19:23:55.000000000 +0000
+++ b/ext/exif/exif.c	2025-11-18 21:43:27.154692138 +0000
@@ -3249,6 +3249,7 @@
 
 #define REQUIRE_NON_EMPTY() do { \
 	if (byte_count == 0) { \
+		EFREE_IF(outside); \
 		exif_error_docref("exif_read_data#error_ifd" EXIFERR_CC, ImageInfo, E_WARNING, "Process tag(x%04X=%s): Cannot be empty", tag, exif_get_tagname_debug(tag, tag_table)); \
 		return false; \
 	} \
diff '--color=auto' -Naur a/ext/ftp/ftp.c b/ext/ftp/ftp.c
--- a/ext/ftp/ftp.c	2025-10-21 19:23:55.000000000 +0000
+++ b/ext/ftp/ftp.c	2025-11-18 21:43:27.156215014 +0000
@@ -1625,7 +1625,7 @@
 
 /* {{{ data_available */
 int
-data_available(ftpbuf_t *ftp, php_socket_t s)
+data_available(ftpbuf_t *ftp, php_socket_t s, bool silent)
 {
 	int		n;
 
@@ -1633,6 +1633,9 @@
 	if (n < 1) {
 		char buf[256];
 		if (n == 0) {
+			if (silent) {
+				return 0;
+			}
 #ifdef PHP_WIN32
 			_set_errno(ETIMEDOUT);
 #else
@@ -1961,7 +1964,9 @@
 		done = 0;
 	}
 
-	while (!done && data_available(ftp, fd)) {
+	/* Don't report timeouts on the control channel if we're negotiating a shutdown already.
+	 * Some servers don't put a final response. */
+	while (!done && data_available(ftp, fd, true)) {
 		ERR_clear_error();
 		nread = SSL_read(ssl_handle, buf, sizeof(buf));
 		if (nread <= 0) {
@@ -2219,7 +2224,7 @@
 	data = ftp->data;
 
 	/* check if there is already more data */
-	if (!data_available(ftp, data->fd)) {
+	if (!data_available(ftp, data->fd, false)) {
 		return PHP_FTP_MOREDATA;
 	}
 
diff '--color=auto' -Naur a/ext/ftp/php_ftp.c b/ext/ftp/php_ftp.c
--- a/ext/ftp/php_ftp.c	2025-10-21 19:23:55.000000000 +0000
+++ b/ext/ftp/php_ftp.c	2025-11-18 21:43:27.156953327 +0000
@@ -809,7 +809,7 @@
 }
 /* }}} */
 
-/* {{{ Continues retrieving/sending a file nbronously */
+/* {{{ Continues to retrieve or send a file in non-blocking mode */
 PHP_FUNCTION(ftp_nb_continue)
 {
 	zval		*z_ftp;
@@ -822,7 +822,7 @@
 	GET_FTPBUF(ftp, z_ftp);
 
 	if (!ftp->nb) {
-		php_error_docref(NULL, E_WARNING, "No nbronous transfer to continue");
+		php_error_docref(NULL, E_WARNING, "No non-blocking transfer to continue");
 		RETURN_LONG(PHP_FTP_FAILED);
 	}
 
diff '--color=auto' -Naur a/ext/ftp/tests/005.phpt b/ext/ftp/tests/005.phpt
--- a/ext/ftp/tests/005.phpt	2025-10-21 19:23:55.000000000 +0000
+++ b/ext/ftp/tests/005.phpt	2025-11-18 21:43:27.157413516 +0000
@@ -85,7 +85,7 @@
 Warning: ftp_mkdir(): Command not implemented (7). in %s005.php on line %d
 bool(false)
 
-Warning: ftp_nb_continue(): No nbronous transfer to continue in %s005.php on line %d
+Warning: ftp_nb_continue(): No non-blocking transfer to continue in %s on line %d
 int(0)
 ftp_nb_fget(): Argument #4 ($mode) must be either FTP_ASCII or FTP_BINARY
 ftp_nb_fput(): Argument #4 ($mode) must be either FTP_ASCII or FTP_BINARY
diff '--color=auto' -Naur a/ext/gd/gd.c b/ext/gd/gd.c
--- a/ext/gd/gd.c	2025-10-21 19:23:55.000000000 +0000
+++ b/ext/gd/gd.c	2025-11-18 21:43:27.157565789 +0000
@@ -3732,9 +3732,11 @@
 		RETURN_THROWS();
 	}
 
-	if (filtertype >= 0 && filtertype <= IMAGE_FILTER_MAX) {
-		filters[filtertype](INTERNAL_FUNCTION_PARAM_PASSTHRU);
+	if (UNEXPECTED(filtertype < 0 || filtertype > IMAGE_FILTER_MAX)) {
+		zend_argument_value_error(2, "must be one of the IMG_FILTER_* filter constants");
+		RETURN_THROWS();
 	}
+	filters[filtertype](INTERNAL_FUNCTION_PARAM_PASSTHRU);
 }
 /* }}} */
 
diff '--color=auto' -Naur a/ext/gd/tests/gh19955.phpt b/ext/gd/tests/gh19955.phpt
--- a/ext/gd/tests/gh19955.phpt	2025-10-21 19:23:55.000000000 +0000
+++ b/ext/gd/tests/gh19955.phpt	2025-11-18 21:43:27.158813219 +0000
@@ -4,6 +4,10 @@
 gd
 --CREDITS--
 YuanchengJiang
+--SKIPIF--
+<?php
+if(!function_exists('imagefttext')) die('skip imagefttext() not available');
+?>
 --FILE--
 <?php
 ini_set('error_reporting', E_ALL&~E_WARNING);
diff '--color=auto' -Naur a/ext/gd/tests/imagefilter_invalid_filter_error.phpt b/ext/gd/tests/imagefilter_invalid_filter_error.phpt
--- a/ext/gd/tests/imagefilter_invalid_filter_error.phpt	1970-01-01 00:00:00.000000000 +0000
+++ b/ext/gd/tests/imagefilter_invalid_filter_error.phpt	2025-11-18 21:43:27.159018506 +0000
@@ -0,0 +1,16 @@
+--TEST--
+GH-20070: Testing wrong parameter passing in imagefilter() of GD library
+--EXTENSIONS--
+gd
+--FILE--
+<?php
+$image = imagecreatetruecolor(1, 1);
+
+try {
+    var_dump(imagefilter($image, -1));
+} catch (Throwable $e) {
+    echo $e::class, ': ', $e->getMessage(), "\n";
+}
+?>
+--EXPECT--
+ValueError: imagefilter(): Argument #2 ($filter) must be one of the IMG_FILTER_* filter constants
diff '--color=auto' -Naur a/ext/iconv/config.m4 b/ext/iconv/config.m4
--- a/ext/iconv/config.m4	2025-10-21 19:23:55.000000000 +0000
+++ b/ext/iconv/config.m4	2025-11-18 21:43:27.159135457 +0000
@@ -83,6 +83,20 @@
   AS_VAR_IF([php_cv_iconv_errno], [yes],,
     [AC_MSG_FAILURE([The iconv check failed, 'errno' is missing.])])
 
+  dnl iconv on some platforms (NetBSD pre-10, Solaris) may have a non-standard
+  dnl const input parameter; libiconv may imitate this on those platforms.
+  AC_CACHE_CHECK([if iconv input parameter is const (non-standard)], [php_cv_iconv_const],
+    [AC_COMPILE_IFELSE([AC_LANG_SOURCE([
+#include <iconv.h>
+
+size_t iconv(iconv_t cd, const char **src, size_t *srcleft, char **dst, size_t *dstleft);
+    ])],
+    [php_cv_iconv_const=const],
+    [php_cv_iconv_const=non-const])])
+  dnl non-const is just used for display, set it back
+  AS_VAR_IF([php_cv_iconv_const], [non-const],
+    [php_cv_iconv_const=])
+
   AC_CACHE_CHECK([if iconv supports //IGNORE], [php_cv_iconv_ignore],
     [AC_RUN_IFELSE([AC_LANG_SOURCE([
 #include <iconv.h>
@@ -120,7 +134,7 @@
   PHP_NEW_EXTENSION([iconv],
     [iconv.c],
     [$ext_shared],,
-    [-DZEND_ENABLE_STATIC_TSRMLS_CACHE=1])
+    [-DZEND_ENABLE_STATIC_TSRMLS_CACHE=1 -DICONV_CONST=$php_cv_iconv_const])
   PHP_SUBST([ICONV_SHARED_LIBADD])
   PHP_INSTALL_HEADERS([ext/iconv], [php_iconv.h])
 fi
diff '--color=auto' -Naur a/ext/iconv/iconv.c b/ext/iconv/iconv.c
--- a/ext/iconv/iconv.c	2025-10-21 19:23:55.000000000 +0000
+++ b/ext/iconv/iconv.c	2025-11-18 21:43:27.159565815 +0000
@@ -43,11 +43,11 @@
 #undef iconv
 #endif
 
-#if defined(__NetBSD__)
-// unfortunately, netbsd has still the old non posix conformant signature
-// libiconv tends to match the eventual system's iconv too.
-#define ICONV_CONST const
-#else
+/* iconv can have different constiness for src on some platforms;
+ * this is explained in config.m4. On Windows, it's always non-const,
+ * but it can be awkward to set that on the command line. Do it here.
+ */
+#ifndef ICONV_CONST
 #define ICONV_CONST
 #endif
 
diff '--color=auto' -Naur a/ext/intl/locale/locale_methods.c b/ext/intl/locale/locale_methods.c
--- a/ext/intl/locale/locale_methods.c	2025-10-21 19:23:55.000000000 +0000
+++ b/ext/intl/locale/locale_methods.c	2025-11-18 21:43:27.160336585 +0000
@@ -1290,6 +1290,7 @@
 		/* canonicalize lang_tag */
 		can_lang_tag = get_icu_value_internal( lang_tag , LOC_CANONICALIZE_TAG , &result ,  0);
 		if( result <=0) {
+			zend_string_release_ex( can_loc_range, false );
 			intl_error_set( NULL, status,
 				"locale_filter_matches : unable to canonicalize lang_tag" , 0 );
 			RETURN_FALSE;
diff '--color=auto' -Naur a/ext/libxml/libxml.c b/ext/libxml/libxml.c
--- a/ext/libxml/libxml.c	2025-10-21 19:23:55.000000000 +0000
+++ b/ext/libxml/libxml.c	2025-11-18 21:43:27.160960713 +0000
@@ -40,6 +40,7 @@
 #ifdef LIBXML_SCHEMAS_ENABLED
 #include <libxml/relaxng.h>
 #include <libxml/xmlschemas.h>
+#include <libxml/xmlschemastypes.h>
 #endif
 
 #include "php_libxml.h"
@@ -929,7 +930,16 @@
 	if (!_php_libxml_initialized) {
 		/* we should be the only one's to ever init!! */
 		ZEND_IGNORE_LEAKS_BEGIN();
+
 		xmlInitParser();
+#ifdef ZTS
+# ifdef LIBXML_SCHEMAS_ENABLED
+		xmlSchemaInitTypes();
+# endif
+# ifdef LIBXML_RELAXNG_ENABLED
+		xmlRelaxNGInitTypes();
+# endif
+#endif
 		ZEND_IGNORE_LEAKS_END();
 
 		_php_libxml_default_entity_loader = xmlGetExternalEntityLoader();
diff '--color=auto' -Naur a/ext/mysqli/tests/bug67563.phpt b/ext/mysqli/tests/bug67563.phpt
--- a/ext/mysqli/tests/bug67563.phpt	2025-10-21 19:23:55.000000000 +0000
+++ b/ext/mysqli/tests/bug67563.phpt	2025-11-18 21:43:27.161579000 +0000
@@ -6,15 +6,12 @@
 <?php
 require_once 'connect.inc';
 
-if ($host !== '127.0.0.1')
-    die('skip local test');
-
 if (@stream_socket_client('udp://[::1]:8888') === false)
-    die('skip no IPv6 support 2');
+    die('skip no IPv6 support');
 
-if (!$link = @my_mysqli_connect($host, $user, $passwd, $db, $port, $socket)) {
-    die(sprintf("SKIP Cannot connect to the server using host=%s, user=%s, passwd=***, dbname=%s, port=%s, socket=%s\n",
-        $host, $user, $db, $port, $socket));
+if (!$link = @my_mysqli_connect('[::1]', $user, $passwd, $db, $port, $socket)) {
+    die(sprintf("SKIP Cannot connect to the server using host=[::1], user=%s, passwd=***, dbname=%s, port=%s, socket=%s\n",
+        $user, $db, $port, $socket));
 }
 ?>
 --INI--
diff '--color=auto' -Naur a/ext/mysqli/tests/mysqli_fetch_field_types.phpt b/ext/mysqli/tests/mysqli_fetch_field_types.phpt
--- a/ext/mysqli/tests/mysqli_fetch_field_types.phpt	2025-10-21 19:23:55.000000000 +0000
+++ b/ext/mysqli/tests/mysqli_fetch_field_types.phpt	2025-11-18 21:43:27.161740395 +0000
@@ -90,6 +90,7 @@
         // MYSQLI_TYPE_GEOMETRY => array('GEOMETRY', 'TODO add testing'),
         MYSQLI_TYPE_NEWDECIMAL => array('DECIMAL', '1.1'),
         MYSQLI_TYPE_BIT => array('BIT', 0),
+        MYSQLI_TYPE_JSON => array('JSON', '[]'),
     );
 
     foreach ($datatypes as $php_type => $datatype) {
diff '--color=auto' -Naur a/ext/mysqlnd/mysqlnd_connection.c b/ext/mysqlnd/mysqlnd_connection.c
--- a/ext/mysqlnd/mysqlnd_connection.c	2025-10-21 19:23:55.000000000 +0000
+++ b/ext/mysqlnd/mysqlnd_connection.c	2025-11-18 21:43:27.161983384 +0000
@@ -557,7 +557,14 @@
 		if (hostname.s[0] != '[' && mysqlnd_fast_is_ipv6_address(hostname.s)) {
 			transport.l = mnd_sprintf(&transport.s, 0, "tcp://[%s]:%u", hostname.s, port);
 		} else {
-			transport.l = mnd_sprintf(&transport.s, 0, "tcp://%s:%u", hostname.s, port);
+			/* Not ipv6, but could already contain a port number, in which case we should not add an extra port.
+			 * See GH-8978. In a port doubling scenario, the first port would be used so we do the same to keep BC. */
+			if (strchr(hostname.s, ':')) {
+				/* TODO: Ideally we should be able to get rid of this workaround in the future. */
+				transport.l = mnd_sprintf(&transport.s, 0, "tcp://%s", hostname.s);
+			} else {
+				transport.l = mnd_sprintf(&transport.s, 0, "tcp://%s:%u", hostname.s, port);
+			}
 		}
 	}
 	DBG_INF_FMT("transport=%s", transport.s? transport.s:"OOM");
diff '--color=auto' -Naur a/ext/opcache/ZendAccelerator.c b/ext/opcache/ZendAccelerator.c
--- a/ext/opcache/ZendAccelerator.c	2025-10-21 19:23:55.000000000 +0000
+++ b/ext/opcache/ZendAccelerator.c	2025-11-18 21:43:27.162777303 +0000
@@ -4443,16 +4443,6 @@
 		}
 	}
 
-	if (EG(zend_constants)) {
-		EG(persistent_constants_count) = EG(zend_constants)->nNumUsed;
-	}
-	if (EG(function_table)) {
-		EG(persistent_functions_count) = EG(function_table)->nNumUsed;
-	}
-	if (EG(class_table)) {
-		EG(persistent_classes_count)   = EG(class_table)->nNumUsed;
-	}
-
 	size_t old_map_ptr_last = CG(map_ptr_last);
 	if (zend_map_ptr_static_last != ZCSG(map_ptr_static_last) || old_map_ptr_last != ZCSG(map_ptr_last)) {
 		CG(map_ptr_last) = ZCSG(map_ptr_last);
@@ -4722,6 +4712,12 @@
 
 		preload_load(orig_map_ptr_static_last);
 
+		/* Update persistent counts, as shutdown will discard anything past
+		 * that, and these tables are aliases to global ones at this point. */
+		EG(persistent_functions_count) = EG(function_table)->nNumUsed;
+		EG(persistent_classes_count)   = EG(class_table)->nNumUsed;
+		EG(persistent_constants_count) = EG(zend_constants)->nNumUsed;
+
 		/* Store individual scripts with unlinked classes */
 		HANDLE_BLOCK_INTERRUPTIONS();
 		SHM_UNPROTECT();
diff '--color=auto' -Naur a/ext/opcache/jit/ir/ir.h b/ext/opcache/jit/ir/ir.h
--- a/ext/opcache/jit/ir/ir.h	2025-10-21 19:23:55.000000000 +0000
+++ b/ext/opcache/jit/ir/ir.h	2025-11-18 21:43:27.164218814 +0000
@@ -257,6 +257,8 @@
 	_(UGE,          d2,   def, def, ___) /* unsigned greater or equal   */ \
 	_(ULE,          d2,   def, def, ___) /* unsigned less or equal      */ \
 	_(UGT,          d2,   def, def, ___) /* unsigned greater            */ \
+	_(ORDERED,      d2,   def, def, ___) /* both operands are not NAN   */ \
+	_(UNORDERED,    d2,   def, def, ___) /* one of operands is NAN      */ \
 	\
 	/* arithmetic ops                                                   */ \
 	_(ADD,          d2C,  def, def, ___) /* addition                    */ \
@@ -1032,6 +1034,7 @@
 #define IR_ERROR_UNSUPPORTED_CODE_RULE           3
 #define IR_ERROR_LINK                            4
 #define IR_ERROR_ENCODE                          5
+#define IR_ERROR_TOO_LARGE                       6
 
 /* IR Memmory Allocation */
 #ifndef ir_mem_malloc
diff '--color=auto' -Naur a/ext/opcache/jit/ir/ir_aarch64.dasc b/ext/opcache/jit/ir/ir_aarch64.dasc
--- a/ext/opcache/jit/ir/ir_aarch64.dasc	2025-10-21 19:23:55.000000000 +0000
+++ b/ext/opcache/jit/ir/ir_aarch64.dasc	2025-11-18 21:43:27.165565892 +0000
@@ -658,16 +658,35 @@
 			flags = IR_OP2_MUST_BE_IN_REG;
 			constraints->tmp_regs[0] = IR_TMP_REG(3, IR_ADDR, IR_LOAD_SUB_REF, IR_DEF_SUB_REF);
 			n = 1;
+			insn = &ctx->ir_base[ref];
+			if (IR_IS_CONST_REF(insn->op2)) {
+				constraints->tmp_regs[1] = IR_TMP_REG(2, IR_ADDR, IR_LOAD_SUB_REF, IR_DEF_SUB_REF);
+				n = 2;
+			}
 			break;
 		case IR_VA_ARG:
 			flags = IR_USE_MUST_BE_IN_REG | IR_OP2_MUST_BE_IN_REG;
 			constraints->tmp_regs[0] = IR_TMP_REG(3, IR_ADDR, IR_LOAD_SUB_REF, IR_SAVE_SUB_REF);
 			n = 1;
+			insn = &ctx->ir_base[ref];
+			if (IR_IS_CONST_REF(insn->op2)) {
+				constraints->tmp_regs[1] = IR_TMP_REG(2, IR_ADDR, IR_LOAD_SUB_REF, IR_DEF_SUB_REF);
+				n = 2;
+			}
 			break;
 		case IR_VA_COPY:
 			flags = IR_OP2_MUST_BE_IN_REG | IR_OP3_MUST_BE_IN_REG;
 			constraints->tmp_regs[0] = IR_TMP_REG(1, IR_ADDR, IR_LOAD_SUB_REF, IR_DEF_SUB_REF);
 			n = 1;
+			insn = &ctx->ir_base[ref];
+			if (IR_IS_CONST_REF(insn->op2)) {
+				constraints->tmp_regs[n] = IR_TMP_REG(2, IR_ADDR, IR_LOAD_SUB_REF, IR_DEF_SUB_REF);
+				n++;
+			}
+			if (IR_IS_CONST_REF(insn->op3)) {
+				constraints->tmp_regs[n] = IR_TMP_REG(3, IR_ADDR, IR_LOAD_SUB_REF, IR_DEF_SUB_REF);
+				n++;
+			}
 			break;
 	}
 	constraints->tmps_count = n;
@@ -728,6 +747,9 @@
 				return IR_CMP_FP;
 			}
 			break;
+		case IR_ORDERED:
+		case IR_UNORDERED:
+			return IR_CMP_FP;
 		case IR_ADD:
 		case IR_SUB:
 			if (IR_IS_TYPE_INT(insn->type)) {
@@ -1024,7 +1046,7 @@
 		case IR_IF:
 			if (!IR_IS_CONST_REF(insn->op2) && ctx->use_lists[insn->op2].count == 1) {
 				op2_insn = &ctx->ir_base[insn->op2];
-				if (op2_insn->op >= IR_EQ && op2_insn->op <= IR_UGT) {
+				if (op2_insn->op >= IR_EQ && op2_insn->op <= IR_UNORDERED) {
 					if (IR_IS_TYPE_INT(ctx->ir_base[op2_insn->op1].type)) {
 						ctx->rules[insn->op2] = IR_FUSED | IR_CMP_INT;
 						return IR_CMP_AND_BRANCH_INT;
@@ -1047,7 +1069,7 @@
 		case IR_GUARD_NOT:
 			if (!IR_IS_CONST_REF(insn->op2) && ctx->use_lists[insn->op2].count == 1) {
 				op2_insn = &ctx->ir_base[insn->op2];
-				if (op2_insn->op >= IR_EQ && op2_insn->op <= IR_UGT
+				if (op2_insn->op >= IR_EQ && op2_insn->op <= IR_UNORDERED
 					// TODO: register allocator may clobber operands of CMP before they are used in the GUARD_CMP
 				 && (insn->op2 == ref - 1 ||
 				     (insn->op2 == ctx->prev_ref[ref] - 1
@@ -1091,6 +1113,9 @@
 						ctx->flags2 |= IR_HAS_VA_ARG_GP|IR_HAS_VA_ARG_FP;
 					}
 				}
+			} else {
+				/* va_list may escape */
+				ctx->flags2 |= IR_HAS_VA_ARG_GP|IR_HAS_VA_ARG_FP;
 			}
 			return IR_VA_START;
 		case IR_VA_END:
@@ -2972,6 +2997,12 @@
 		case IR_UGT:
 			|	cset Rw(def_reg), hi
 			break;
+		case IR_ORDERED:
+			|	cset Rw(def_reg), vc
+			break;
+		case IR_UNORDERED:
+			|	cset Rw(def_reg), vs
+			break;
 	}
 	if (IR_REG_SPILLED(ctx->regs[def][0])) {
 		ir_emit_store(ctx, insn->type, def, def_reg);
@@ -3046,7 +3077,7 @@
 	ir_get_true_false_blocks(ctx, b, &true_block, &false_block);
 	if (true_block == next_block) {
 		/* swap to avoid unconditional JMP */
-		if (int_cmp || op == IR_EQ || op == IR_NE) {
+		if (int_cmp || op == IR_EQ || op == IR_NE || op == IR_ORDERED || op == IR_UNORDERED) {
 			op ^= 1; // reverse
 		} else {
 			op ^= 5; // reverse
@@ -3126,6 +3157,11 @@
 			case IR_UGT:
 				|	bhi =>true_block
 				break;
+			case IR_ORDERED:
+				|	bvc =>true_block
+				break;
+			case IR_UNORDERED:
+				|	bvs =>true_block
 //			case IR_ULT: fprintf(stderr, "\tjb .LL%d\n", true_block); break;
 //			case IR_UGE: fprintf(stderr, "\tjae .LL%d\n", true_block); break;
 //			case IR_ULE: fprintf(stderr, "\tjbe .LL%d\n", true_block); break;
@@ -4443,11 +4479,7 @@
 	ir_reg tmp_reg = ctx->regs[def][3];
 	int32_t offset;
 
-	if (ctx->use_lists[def].count == 1) {
-		/* dead load */
-		return;
-	}
-	IR_ASSERT(def_reg != IR_REG_NONE && tmp_reg != IR_REG_NONE);
+	IR_ASSERT((def_reg != IR_REG_NONE || ctx->use_lists[def].count == 1) && tmp_reg != IR_REG_NONE);
 	if (op2_reg != IR_REG_NONE) {
 		if (IR_REG_SPILLED(op2_reg)) {
 			op2_reg = IR_REG_NUM(op2_reg);
@@ -4460,10 +4492,12 @@
 		offset = ir_local_offset(ctx, &ctx->ir_base[insn->op2]);
 	}
 	|	ldr Rx(tmp_reg), [Rx(op2_reg), #offset]
-	ir_emit_load_mem(ctx, type, def_reg, IR_MEM_BO(tmp_reg, 0));
+	if (def_reg  != IR_REG_NONE) {
+		ir_emit_load_mem(ctx, type, def_reg, IR_MEM_BO(tmp_reg, 0));
+	}
 	|	add Rx(tmp_reg), Rx(tmp_reg), #IR_MAX(ir_type_size[type], sizeof(void*))
 	|	str Rx(tmp_reg), [Rx(op2_reg), #offset]
-	if (IR_REG_SPILLED(ctx->regs[def][0])) {
+	if (def_reg != IR_REG_NONE && IR_REG_SPILLED(ctx->regs[def][0])) {
 		ir_emit_store(ctx, type, def, def_reg);
 	}
 #else
@@ -4475,11 +4509,7 @@
 	ir_reg tmp_reg = ctx->regs[def][3];
 	int32_t offset;
 
-	if (ctx->use_lists[def].count == 1) {
-		/* dead load */
-		return;
-	}
-	IR_ASSERT(def_reg != IR_REG_NONE && tmp_reg != IR_REG_NONE);
+	IR_ASSERT((def_reg != IR_REG_NONE || ctx->use_lists[def].count == 1) && tmp_reg != IR_REG_NONE);
 	if (op2_reg != IR_REG_NONE) {
 		if (IR_REG_SPILLED(op2_reg)) {
 			op2_reg = IR_REG_NUM(op2_reg);
@@ -4498,13 +4528,17 @@
 		|	ldr Rx(IR_REG_INT_TMP), [Rx(op2_reg), #(offset+offsetof(ir_va_list, gr_top))]
 		|	sxtw Rx(tmp_reg), Rw(tmp_reg)
 		|	add Rx(IR_REG_INT_TMP), Rx(tmp_reg), Rx(IR_REG_INT_TMP)
-		|	ldr Rx(def_reg), [Rx(IR_REG_INT_TMP)]
+		if (def_reg  != IR_REG_NONE) {
+			|	ldr Rx(def_reg), [Rx(IR_REG_INT_TMP)]
+		}
 		|	add Rw(tmp_reg), Rw(tmp_reg), #sizeof(void*)
 		|	str Rw(tmp_reg), [Rx(op2_reg), #(offset+offsetof(ir_va_list, gr_offset))]
 		|	b >2
 		|1:
 		|	ldr Rx(tmp_reg), [Rx(op2_reg), #(offset+offsetof(ir_va_list, stack))]
-		|	ldr Rx(def_reg), [Rx(tmp_reg)]
+		if (def_reg  != IR_REG_NONE) {
+			|	ldr Rx(def_reg), [Rx(tmp_reg)]
+		}
 		|	add Rx(tmp_reg), Rx(tmp_reg), #sizeof(void*)
 		|	str Rx(tmp_reg), [Rx(op2_reg), #(offset+offsetof(ir_va_list, stack))]
 		|2:
@@ -4515,18 +4549,22 @@
 		|	ldr Rx(IR_REG_INT_TMP), [Rx(op2_reg), #(offset+offsetof(ir_va_list, vr_top))]
 		|	sxtw Rx(tmp_reg), Rw(tmp_reg)
 		|	add Rx(IR_REG_INT_TMP), Rx(tmp_reg), Rx(IR_REG_INT_TMP)
-		|	ldr Rd(def_reg-IR_REG_FP_FIRST), [Rx(IR_REG_INT_TMP)]
+		if (def_reg  != IR_REG_NONE) {
+			|	ldr Rd(def_reg-IR_REG_FP_FIRST), [Rx(IR_REG_INT_TMP)]
+		}
 		|	add Rw(tmp_reg), Rw(tmp_reg), #16
 		|	str Rw(tmp_reg), [Rx(op2_reg), #(offset+offsetof(ir_va_list, vr_offset))]
 		|	b >2
 		|1:
 		|	ldr Rx(tmp_reg), [Rx(op2_reg), #(offset+offsetof(ir_va_list, stack))]
-		|	ldr Rd(def_reg-IR_REG_FP_FIRST), [Rx(tmp_reg)]
+		if (def_reg  != IR_REG_NONE) {
+			|	ldr Rd(def_reg-IR_REG_FP_FIRST), [Rx(tmp_reg)]
+		}
 		|	add Rx(tmp_reg), Rx(tmp_reg), #sizeof(void*)
 		|	str Rx(tmp_reg), [Rx(op2_reg), #(offset+offsetof(ir_va_list, stack))]
 		|2:
 	}
-	if (IR_REG_SPILLED(ctx->regs[def][0])) {
+	if (def_reg != IR_REG_NONE && IR_REG_SPILLED(ctx->regs[def][0])) {
 		ir_emit_store(ctx, type, def, def_reg);
 	}
 #endif
@@ -5359,6 +5397,11 @@
 			case IR_GT:
 				|	bgt &addr
 				break;
+			case IR_ORDERED:
+				|	bvc &addr
+				break;
+			case IR_UNORDERED:
+				|	bvs &addr
 //			case IR_ULT: fprintf(stderr, "\tjb .LL%d\n", true_block); break;
 //			case IR_UGE: fprintf(stderr, "\tjae .LL%d\n", true_block); break;
 //			case IR_ULE: fprintf(stderr, "\tjbe .LL%d\n", true_block); break;
@@ -6143,6 +6186,14 @@
 	dasm_setup(&data.dasm_state, dasm_actions);
 	/* labels for each block + for each constant + rodata label + jmp_table label + for each entry + exit_table label */
 	dasm_growpc(&data.dasm_state, ctx->cfg_blocks_count + 1 + ctx->consts_count + 1 + 1 + 1 + ctx->entries_count + 1);
+	if (data.dasm_state->status != DASM_S_OK) {
+		IR_ASSERT(data.dasm_state->status == DASM_S_NOMEM);
+		dasm_free(&data.dasm_state);
+		ctx->data = NULL;
+		ctx->status = IR_ERROR_TOO_LARGE;
+		return NULL;
+	}
+
 	data.emit_constants = ir_bitset_malloc(ctx->consts_count);
 
 	if (!(ctx->flags & IR_SKIP_PROLOGUE)) {
@@ -6509,12 +6560,20 @@
 		return NULL;
 	}
 
+	if (data.dasm_state->status != DASM_S_OK) {
+		IR_ASSERT(data.dasm_state->status == DASM_S_NOMEM);
+		dasm_free(&data.dasm_state);
+		ctx->data = NULL;
+		ctx->status = IR_ERROR_TOO_LARGE;
+		return NULL;
+	}
+
 	ret = dasm_link(&data.dasm_state, size_ptr);
 	if (ret != DASM_S_OK) {
-		IR_ASSERT(0);
+		IR_ASSERT(ret == DASM_S_NOMEM);
 		dasm_free(&data.dasm_state);
 		ctx->data = NULL;
-		ctx->status = IR_ERROR_LINK;
+		ctx->status = (ret == DASM_S_NOMEM) ? IR_ERROR_TOO_LARGE : IR_ERROR_LINK;
 		return NULL;
 	}
 	size = *size_ptr;
diff '--color=auto' -Naur a/ext/opcache/jit/ir/ir_check.c b/ext/opcache/jit/ir/ir_check.c
--- a/ext/opcache/jit/ir/ir_check.c	2025-10-21 19:23:55.000000000 +0000
+++ b/ext/opcache/jit/ir/ir_check.c	2025-11-18 21:43:27.166635206 +0000
@@ -36,16 +36,46 @@
 	IR_ASSERT((IR_UGT ^ 3) == IR_ULT);
 	IR_ASSERT((IR_ULE ^ 3) == IR_UGE);
 	IR_ASSERT((IR_UGE ^ 3) == IR_ULE);
+	IR_ASSERT((IR_ORDERED ^ 1) == IR_UNORDERED);
 
 	IR_ASSERT(IR_ADD + 1 == IR_SUB);
 }
 
-static bool ir_check_use_list(const ir_ctx *ctx, ir_ref from, ir_ref to)
+typedef struct {
+	ir_arena  *arena;
+	ir_bitset *use_set;
+	ir_bitset *input_set;
+} ir_check_ctx;
+
+static bool ir_check_use_list(ir_check_ctx *check_ctx, const ir_ctx *ctx, ir_ref from, ir_ref to)
 {
 	ir_ref n, *p;
 	ir_use_list *use_list = &ctx->use_lists[from];
 
 	n = use_list->count;
+	if (n > 16) {
+		/* Avoid quadratic complexity by maintaining a temporary bit-set */
+		ir_bitset set;
+
+		if (!check_ctx->use_set || !(set = check_ctx->use_set[from])) {
+			if (!check_ctx->arena) {
+				check_ctx->arena = ir_arena_create(sizeof(ir_arena) +
+					ctx->insns_count * sizeof(ir_bitset) +
+					ir_bitset_len(ctx->insns_count) * sizeof(ir_bitset_base_t));
+			}
+			if (!check_ctx->use_set) {
+				check_ctx->use_set = ir_arena_alloc(&check_ctx->arena, ctx->insns_count * sizeof(ir_bitset));
+				memset(check_ctx->use_set, 0, ctx->insns_count * sizeof(ir_bitset));
+			}
+			check_ctx->use_set[from] = set = (ir_bitset)ir_arena_alloc(&check_ctx->arena,
+				ir_bitset_len(ctx->insns_count) * sizeof(ir_bitset_base_t));
+			memset(set, 0, ir_bitset_len(ctx->insns_count) * sizeof(ir_bitset_base_t));
+			for (p = &ctx->use_edges[use_list->refs]; n > 0; p++, n--) {
+				ir_bitset_incl(set, *p);
+			}
+		}
+		return ir_bitset_in(set, to);
+	}
 	for (p = &ctx->use_edges[use_list->refs]; n > 0; p++, n--) {
 		if (*p == to) {
 			return 1;
@@ -54,12 +84,35 @@
 	return 0;
 }
 
-static bool ir_check_input_list(const ir_ctx *ctx, ir_ref from, ir_ref to)
+static bool ir_check_input_list(ir_check_ctx *check_ctx, const ir_ctx *ctx, ir_ref from, ir_ref to)
 {
 	ir_insn *insn = &ctx->ir_base[to];
 	ir_ref n, j, *p;
 
 	n = ir_input_edges_count(ctx, insn);
+	if (n > 16) {
+		/* Avoid quadratic complexity by maintaining a temporary bit-set */
+		ir_bitset set;
+
+		if (!check_ctx->input_set || !(set = check_ctx->input_set[to])) {
+			if (!check_ctx->arena) {
+				check_ctx->arena = ir_arena_create(sizeof(ir_arena) +
+					ctx->insns_count * sizeof(ir_bitset) +
+					ir_bitset_len(ctx->insns_count) * sizeof(ir_bitset_base_t));
+			}
+			if (!check_ctx->input_set) {
+				check_ctx->input_set = ir_arena_alloc(&check_ctx->arena, ctx->insns_count * sizeof(ir_bitset));
+				memset(check_ctx->input_set, 0, ctx->insns_count * sizeof(ir_bitset));
+			}
+			check_ctx->input_set[to] = set = (ir_bitset)ir_arena_alloc(&check_ctx->arena,
+				ir_bitset_len(ctx->insns_count) * sizeof(ir_bitset_base_t));
+			memset(set, 0, ir_bitset_len(ctx->insns_count) * sizeof(ir_bitset_base_t));
+			for (j = 1, p = insn->ops + 1; j <= n; j++, p++) {
+				if (*p > 0) ir_bitset_incl(set, *p);
+			}
+		}
+		return ir_bitset_in(set, from);
+	}
 	for (j = 1, p = insn->ops + 1; j <= n; j++, p++) {
 		if (*p == from) {
 			return 1;
@@ -93,6 +146,11 @@
 	ir_type type;
 	uint32_t flags;
 	bool ok = 1;
+	ir_check_ctx check_ctx;
+
+	check_ctx.arena = NULL;
+	check_ctx.use_set = NULL;
+	check_ctx.input_set = NULL;
 
 	for (i = IR_UNUSED + 1, insn = ctx->ir_base + i; i < ctx->insns_count;) {
 		if (insn->op >= IR_LAST_OP) {
@@ -255,7 +313,7 @@
 			}
 			if (ctx->use_lists
 			 && use > 0
-			 && !ir_check_use_list(ctx, use, i)) {
+			 && !ir_check_use_list(&check_ctx, ctx, use, i)) {
 				fprintf(stderr, "ir_base[%d].ops[%d] is not in use list (%d)\n", i, j, use);
 				ok = 0;
 			}
@@ -313,7 +371,7 @@
 
 			for (p = &ctx->use_edges[use_list->refs]; n > 0; p++, n--) {
 				use = *p;
-				if (!ir_check_input_list(ctx, i, use)) {
+				if (!ir_check_input_list(&check_ctx, ctx, i, use)) {
 					fprintf(stderr, "ir_base[%d] is in use list of ir_base[%d]\n", use, i);
 					ok = 0;
 				}
@@ -393,6 +451,10 @@
 		insn += n;
 	}
 
+	if (check_ctx.arena) {
+		ir_arena_free(check_ctx.arena);
+	}
+
 //	if (!ok) {
 //		ir_dump_codegen(ctx, stderr);
 //	}
diff '--color=auto' -Naur a/ext/opcache/jit/ir/ir_emit.c b/ext/opcache/jit/ir/ir_emit.c
--- a/ext/opcache/jit/ir/ir_emit.c	2025-10-21 19:23:55.000000000 +0000
+++ b/ext/opcache/jit/ir/ir_emit.c	2025-11-18 21:43:27.166997079 +0000
@@ -32,8 +32,14 @@
   do { \
     size_t _sz = (sz), _need = (need); \
     if (_sz < _need) { \
+      size_t _limit = sizeof(t) * DASM_SEC2POS(1); \
+      if (_need > _limit) { \
+        Dst_REF->status = DASM_S_NOMEM; \
+        return; \
+      } \
       if (_sz < 16) _sz = 16; \
       while (_sz < _need) _sz += _sz; \
+      if (_sz > _limit) _sz = _limit; \
       (p) = (t *)ir_mem_realloc((p), _sz); \
       (sz) = _sz; \
     } \
diff '--color=auto' -Naur a/ext/opcache/jit/ir/ir_fold.h b/ext/opcache/jit/ir/ir_fold.h
